'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _semanticUiTransition = require('semantic-ui-transition');

var _semanticUiTransition2 = _interopRequireDefault(_semanticUiTransition);

var _semanticUiDropdown = require('semantic-ui-dropdown');

var _semanticUiDropdown2 = _interopRequireDefault(_semanticUiDropdown);

var _semanticUiPopup = require('semantic-ui-popup');

var _semanticUiPopup2 = _interopRequireDefault(_semanticUiPopup);

var _reactInlineCss = require('react-inline-css');

var _reactInlineCss2 = _interopRequireDefault(_reactInlineCss);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

require('./semantic-calendar.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Calendar = function (_React$Component) {
    _inherits(Calendar, _React$Component);

    function Calendar(props) {
        _classCallCheck(this, Calendar);

        var _this = _possibleConstructorReturn(this, (Calendar.__proto__ || Object.getPrototypeOf(Calendar)).call(this, props));

        _jquery2.default.fn.transition = _semanticUiTransition2.default;
        _jquery2.default.fn.popup = _semanticUiPopup2.default;
        _jquery2.default.fn.dropdown = _semanticUiDropdown2.default;
        return _this;
    }

    _createClass(Calendar, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            var context = this;

            (0, _jquery2.default)(this.refs.calendar).find('input').val((0, _moment2.default)(this.props.initialDate).format());
            (0, _jquery2.default)(this.refs.calendar).calendar({
                startCalendar: this.props.startCalendar || null,
                endCalendar: this.props.endCalendar || null,
                startMode: this.props.startMode || false,
                type: this.props.type || 'date',
                ampm: this.props.ampm || false,
                on: this.props.on || null,
                minDate: this.props.minDate || null,
                maxDate: this.props.maxDate || null,
                monthFirst: this.props.monthFirst || true,
                formatter: this.props.formatter || {},
                inline: this.props.inline || false,
                onChange: function onChange(newDate) {
                    if (_this2.props.onChange) {
                        _this2.props.onChange.call(context, newDate.toISOString());
                    }
                }
            });
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {}
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _reactInlineCss2.default,
                { stylesheet: '\n                .ui.calendar .ui.popup {\n                    max-width: none;\n                    padding: 0;\n                    border: none;\n                    -webkit-user-select: none;\n                    -moz-user-select: none;\n                    -ms-user-select: none;\n                    user-select: none\n                }\n                .ui.calendar .calendar:focus {\n                    outline: 0\n                }\n                .ui.calendar .ui.table.minute,\n                .ui.calendar .ui.table.month,\n                .ui.calendar .ui.table.year {\n                    min-width: 15em\n                }\n                .ui.calendar .ui.table.day {\n                    min-width: 18em\n                }\n                .ui.calendar .ui.table.hour {\n                    min-width: 20em\n                }\n                .ui.calendar .ui.table tr td,\n                .ui.calendar .ui.table tr th {\n                    padding: .5em;\n                    white-space: nowrap\n                }\n                .ui.calendar .ui.table tr th {\n                    border-left: none\n                }\n                .ui.calendar .ui.table tr th .icon {\n                    margin: 0\n                }\n                .ui.calendar .ui.table tr:first-child th {\n                    position: relative;\n                    padding-left: 0;\n                    padding-right: 0\n                }\n                .ui.calendar .ui.table.day tr:first-child th {\n                    border: none\n                }\n                .ui.calendar .ui.table.day tr:nth-child(2) th {\n                    padding-top: .2em;\n                    padding-bottom: .3em\n                }\n                .ui.calendar .ui.table tr td {\n                    padding-left: .1em;\n                    padding-right: .1em\n                }\n                .ui.calendar .ui.table tr .link {\n                    cursor: pointer\n                }\n                .ui.calendar .ui.table tr .prev.link {\n                    width: 14.28571429%;\n                    position: absolute;\n                    left: 0\n                }\n                .ui.calendar .ui.table tr .next.link {\n                    width: 14.28571429%;\n                    position: absolute;\n                    right: 0\n                }\n                .ui.calendar .ui.table tr .disabled {\n                    pointer-events: none;\n                    color: rgba(40, 40, 40, .3)\n                }\n                .ui.calendar .ui.table tr td.today {\n                    font-weight: 700\n                }\n                .ui.calendar .ui.table tr td.range {\n                    background: rgba(0, 0, 0, .05);\n                    color: rgba(0, 0, 0, .95);\n                    box-shadow: none\n                }\n                .ui.calendar .ui.table.inverted tr td.range {\n                    background: rgba(255, 255, 255, .08);\n                    color: #fff;\n                    box-shadow: none\n                }\n                .ui.calendar .calendar.active .ui.table tbody tr td.focus,\n                .ui.calendar .calendar.active .ui.table.inverted tbody tr td.focus,\n                .ui.calendar .calendar:focus .ui.table tbody tr td.focus,\n                .ui.calendar .calendar:focus .ui.table.inverted tbody tr td.focus {\n                    box-shadow: inset 0 0 0 1px #85B7D9\n                }\n            ' },
                _react2.default.createElement(
                    'div',
                    { className: 'ui calendar', ref: 'calendar' },
                    _react2.default.createElement(
                        'div',
                        { className: 'ui input left icon' },
                        _react2.default.createElement('i', { className: 'calendar icon' }),
                        _react2.default.createElement('input', { type: 'text', placeholder: 'Choose Date...', disabled: this.props.disabled })
                    )
                )
            );
        }
    }]);

    return Calendar;
}(_react2.default.Component);

exports.default = Calendar;


Calendar.propTypes = {
    onChange: _react.PropTypes.func,
    initialDate: _react.PropTypes.string.isRequired,
    disabled: _react.PropTypes.bool,
    type: _react.PropTypes.string,
    ampm: _react.PropTypes.bool,
    minDate: _react.PropTypes.func,
    maxDate: _react.PropTypes.func,
    startMode: _react.PropTypes.string,
    monthFirst: _react.PropTypes.bool,
    formatter: _react.PropTypes.object,
    inline: _react.PropTypes.bool,
    on: _react.PropTypes.string,
    startCalendar: _react.PropTypes.func,
    endCalendar: _react.PropTypes.func
};